Automates deployment of containerized applications
CentOS Sources
2017-11-30 78b10da3fc88c5ddf46b68d3dd3ac9b62fdf2cb6
commit | author | age
d03ac3 1 #!/bin/bash
CS 2
3 # Copyright (C) 2016 Red Hat, Inc.
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 3 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
17
18 set -euo pipefail
19 IFS=$'\n\t'
20
21 # This is a small wrapper script that automatically fetches
22 # the storage options from the docker-storage sysconfig file
23 # and passes them to the migrator.
24 #
25 # The script supports both in-container runs and direct
26 # invocation.
27
28 MIGRATOR=/usr/bin/v1.10-migrator-local
29 STORAGE_FILE=/etc/sysconfig/docker-storage
30 GRAPH=/var/lib/docker
31
32 main() {
33
34     # are we in a container?
35     if [[ -n ${container-} ]]; then
36
37         if [[ ! -d /host ]]; then
38             echo "ERROR: Running inside a container, but /host not mounted." >&2
39             exit 1
40         fi
41
42         cp "$MIGRATOR" /host/tmp
43         MIGRATOR="chroot /host /tmp/$(basename $MIGRATOR)"
44         STORAGE_FILE=/host${STORAGE_FILE}
45     fi
46
47     if [ ! -d "$GRAPH" ]; then
48         echo "ERROR: Cannot find docker root dir at \"$GRAPH\"." >&2
49         exit 1
50     fi
51
52     # load storage opts if we can find the file
53     local storage_opts=
54     if [ -r "$STORAGE_FILE" ] && grep -q -E '^DOCKER_STORAGE_OPTIONS\s*=' "$STORAGE_FILE"; then
55         storage_opts=$(sed -n -e 's/^DOCKER_STORAGE_OPTIONS\s*=\s*// p' "$STORAGE_FILE")
56         storage_opts=${storage_opts#\"}
57         storage_opts=${storage_opts%\"}
58     fi
59
60     CMD="$MIGRATOR --graph $GRAPH $storage_opts"
61     echo "RUNNING: $CMD"
62     eval $CMD
63 }
64
65 main "$@"